View Issue Details

IDProjectCategoryView StatusLast Update
0000222Far Manager 1.7x_Commonpublic2008-03-22 16:37
ReporterZuzAssigned ToDrKnS 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Product Version1.71 
Target VersionFixed in Version1.71 
Summary0000222: Не вполне корректная работа (или не работа) с потоками, привязанным к директориям.
Description1. Жмем Shift-F4 вводим имя потока в нотациях
\\?\Volume{GUID}\:streamname
\\?\DriveDir:\:streamname
\\?\Volume{GUID}\path2dir:streamname
\\?\DriveDir:\path2dir:streamname
в результате диалог об ошибке "файл не существует" - при открытии потока, диалог об ошибке "файл не найден" - при сохранении нового потока.

2. Копировщик.
Не работает копирование файла в поток: выдает диалог об ошибке "указанное имя неверно" при копировании в поток с именем:
\\?\Volume{GUID}\:streamname
\\?\Volume{GUID}\path2dir:streamname

P.S. Ясно, что это не все проявления, что-нибудь я забыл.
Additional Information1.71 alpha 2 build 2112
TagsNo tags attached.
Build2330

Activities

Zuz

2006-07-17 01:31

developer   bugnote:0000243

Забыл сказать опции копирования: "Использовать системную функцию копирования" и
"Копировать открытые для записи файлы", на ситуацию никак не влияют (пункт 2).

alexy

2006-09-23 22:35

administrator   bugnote:0000284

А с другими потоками Фар работает? Научи. Тогда посмотрю.

Zuz

2006-09-25 06:17

developer   bugnote:0000290

Да, с потоками FAR работает. В других нотациях проблем не возникает или я пока с ними не столкнулся, проблемы именно с этими нотациями.
А про "научи", я не совсем понял, кого учить? Если FAR, то я б с удовольствием, но кто мне исходники даст ;-)

alexy

2006-09-25 07:08

administrator   bugnote:0000291

Про научить я имел ввиду себя. И это, мне же исходники кто то дал.

Zuz

2006-09-25 08:43

developer   bugnote:0000292

Ну сам, то я умею (точнее думаю, что умею) с потоками работать, я б в баг сие не писал, если б не умел.
А пока не понятно, что от меня требуется, чтобы Вам помочь.

alexy

2006-09-25 09:44

administrator   bugnote:0000293

Ну блин, ну не знаю я русский - вы уже должны это понимать. Я имел ввиду научить меня работать с потоками.

Zuz

2006-09-26 03:42

developer   bugnote:0000298

Начнем с того, что с потоками FAR работать умеет (точнее выполнять некоторые элементарыне операции с ними).
Про потоки, предлагаю почитать здесь:
http://windowssdk.msdn.microsoft.com/en-us/library/ms685571.aspx
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/dnfiles/html/ntfs5.asp
Но суть проблемы с самими потоками не связана, она связана с нотациями имен файлов:
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/fileio/fs/naming_a_volume.asp
http://msdn.microsoft.com/library/default.asp?url=/library/en-us/fileio/fs/naming_a_file.asp

Ещё полезна будет команда mountvol, чтобы смотреть GUID'ы для томов.

Пример:
Создаем папку C:\1
Жмем Shift-F4 вводим C:\1:steamtest.txt
пишем в редакторе Stream test! жмем F2, затем ESC
Смотрим в mountvol Чего у нас там тому C: соответствует.
Пишем (подставляем свой GUID) edit:\\?\Volume{51a3de12-2e1b-11db-a30a-806d6172696f}\1:sreamtest.txt
Вуаля открылся поток.
Но вот сам FAR не умеет некоторые операции совершать для потоков с хитрыми именами как я описал, точнее там какие-то проверки на корректность имен мешают, т.к. тот же FARCmd прекрасно их в FAR'e открывает.
P.S. Кстати проверил на FAR b2131 там часть первого пункта уже поправлена, как минимум после диалога об ошибке поток открывается в редакторе.
P.P.S Я за персоналиями не слижу, поэтому не подскажешь какой язык для тебя родной? ;-)

DrKnS

2008-03-15 11:20

administrator   bugnote:0001331

Тут потоки в общем не при чём, дело в обработке путей "\\?\c:\" и "\\?\Volume{GUID}\".
Заодно поправил еще пару мест c этими путями.

2330/446.

Issue History

Date Modified Username Field Change
2006-07-14 05:01 Zuz New Issue
2006-07-17 01:31 Zuz Note Added: 0000243
2006-09-23 22:35 alexy Note Added: 0000284
2006-09-25 06:17 Zuz Note Added: 0000290
2006-09-25 07:08 alexy Note Added: 0000291
2006-09-25 08:43 Zuz Note Added: 0000292
2006-09-25 09:44 alexy Note Added: 0000293
2006-09-26 03:42 Zuz Note Added: 0000298
2008-03-15 11:19 DrKnS Status new => assigned
2008-03-15 11:19 DrKnS Assigned To => DrKnS
2008-03-15 11:20 DrKnS Note Added: 0001331
2008-03-15 11:20 DrKnS Status assigned => feedback
2008-03-22 16:36 DrKnS Build => 2330
2008-03-22 16:36 DrKnS Status feedback => closed
2008-03-22 16:37 DrKnS Resolution open => fixed
2008-03-22 16:37 DrKnS Fixed in Version => 1.71
2008-03-22 16:37 DrKnS Resolution open => fixed
2008-03-22 16:37 DrKnS Fixed in Version => 1.71